<img src="/looking_glass_icon.png"  width="32px" height="32px"> GNOME Fuzzy App Search
==================

[Fuzzy](https://en.wikipedia.org/wiki/Approximate_string_matching) application search results for [Gnome Search](https://developer.gnome.org/SearchProvider/). Forked from [gnome-fuzzy-search](https://github.com/fffilo/gnome-fuzzy-search).

## Install

### Install from extensions.gnome.org

Go to the GNOME Extensions page of this extension and click on the switch to install.

### Build from source and install
 - download source from [GitLab](https://gitlab.com/Czarlie/gnome-fuzzy-app-search) (clone repository or download zip)
 - from `gnome-fuzzy-app-search` directory execute `make install`
 - press `Alt`+`F2` and enter `r` and press `Enter` to reload extensions (and everything else, too)

## How It Works

The plugin injects its own callback to `getResultSet` method in each registrated provider which appends new search results.
This means that it does not change default result set, just adds new results to existing ones.

The search query is split up into words and [**Levenshtein distances**](https://en.wikipedia.org/wiki/Levenshtein_distance) to the words in the app names are calculated, scored and used to display fuzzy search results.

Keep in mind that although [the extension this is forked from](https://github.com/fffilo/gnome-fuzzy-search) plans to extend more search providers,
I will probably only ever support applications.

![fuzzy search enabled](screenshot_after.png "Fuzzy Search Enabled")
